#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>

// implements:  ls -al | grep a.out | tr a A

int main () {
  int pipe1_fds[2];
  int pipe2_fds[2];
  int pipe1_read_fd, pipe1_write_fd, pipe2_read_fd, pipe2_write_fd, 
    pid1, pid2, pid3;
  pipe (pipe1_fds);
  pipe (pipe2_fds);
  pipe1_read_fd  = pipe1_fds[0];
  pipe1_write_fd = pipe1_fds[1];
  pipe2_read_fd  = pipe2_fds[0];
  pipe2_write_fd = pipe2_fds[1];

  // child 1
  pid1 = fork();
  if (pid1 == 0) {
    // pipe stuff: stdout -> fds1[1]
    dup2 (pipe1_write_fd, 1);
    close (pipe1_read_fd);
    close (pipe1_write_fd);
    close (pipe2_read_fd);
    close (pipe2_write_fd);
    // run first program
    execlp ("ls", "ls", "-al", NULL);
  }

  // child 2
  pid2 = fork();
  if (pid2 == 0) {
    // pipe stuff: stdin  -> fds1[0]
    // pipe stuff: stdout -> fds2[1]
    dup2 (pipe1_read_fd, 0);
    dup2 (pipe2_write_fd, 1);
    close (pipe1_write_fd);
    close (pipe1_read_fd);
    close (pipe2_write_fd);
    close (pipe2_read_fd);
    // run second program
    execlp ("grep", "grep", "a.out", NULL);
  }

  // child 3
  pid3 = fork();
  if (pid3 == 0) {
    // pipe stuff: stdin  -> fds2[0]
    dup2 (pipe2_read_fd, 0);
    close (pipe1_write_fd);
    close (pipe1_read_fd);
    close (pipe2_write_fd);
    close (pipe2_read_fd);
    // run third program
    execlp ("tr", "tr", "rwx", "RWX", NULL);
  }

  // parent
  close (pipe1_read_fd);
  close (pipe1_write_fd);
  close (pipe2_write_fd);
  close (pipe2_read_fd);
  wait (NULL);
  wait (NULL);
  wait (NULL);
};

